library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
--use ieee.numeric_std.all;

entity receptor is
    port (
        clock: in std_logic;
        input: in std_logic;
        
        data: out std_logic_vector(7 downto 0);
        idle: out std_logic
    );
end receptor;

architecture behavioral of receptor is
begin
    process(clock) is
        variable state: integer := 0;
        variable index: integer := 0;
        variable b_counter: integer := 0;
    begin
        if rising_edge(clock) then
            -- idle
            if state = 0 then
                if input = '0' then
                    state := 1;
                    b_counter := 3333;
                end if;

                idle <= '1';
            elsif b_counter = 3333 then
                b_counter := 0;

                case state is
                    -- start
                    when 1 =>
                        index := 0;
                        state := 2;

                        idle <= '0';

                    -- reception
                    when 2 =>
                        data(index) <= input;
                        idle <= '0';

                        if index = 7 then
                            index := 0;
                            state := 3;
                        else
                            index := index + 1;
                        end if;

                    -- stop
                    when 3 =>
                        if index = 2 then
                            state := 0;
                        else
                            index := index + 1;
                        end if;

                        idle <= '0';

                    when others =>
                end case;
            else
                b_counter := b_counter + 1;

                idle <= '0';
            end if;
        end if;
    end process;
end behavioral;
