library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
--use ieee.numeric_std.all;

entity transmitter is
    port (
        clock: in std_logic;
        data: in std_logic_vector(7 downto 0);
        start: in std_logic;
        
        output: out std_logic;
        idle: out std_logic
    );
end transmitter;

architecture behavioral of transmitter is
begin
    process(clock) is
        variable state: integer := 0;
        variable index: integer := 0;
    begin
        if rising_edge(clock) then
            case state is
                -- idle
                when 0 =>
                    if start = '1' then
                        state := 1;
                    end if;

                    output <= '1';
                    idle <= '1';

                -- start
                when 1 =>
                    index := 0;
                    state := 2;

                    output <= '0';
                    idle <= '0';

                -- transmission
                when 2 =>
                    output <= data(index);
                    idle <= '0';

                    if index = 7 then
                        index := 0;
                        state := 3;
                    else
                        index := index + 1;
                    end if;

                -- stop
                when 3 =>
                    if index = 2 then
                        state := 0;
                    else
                        index := index + 1;
                    end if;

                    output <= '1';
                    idle <= '0';

                when others =>
            end case;
        end if;
    end process;
end behavioral;
